/// Autogenerated. Do not modify.
///
/// Profile: 21.60
import 'dart:typed_data';

import '../../base_type.dart';
import '../../data_message.dart';
import '../../definition_message.dart';
import '../../field.dart';
import '../../sub_field.dart';
import '../profile_type.dart';
import 'common_fields.dart';

class DiveGasMessage extends DataMessage {
  DiveGasMessage(
      {definitionMessage,
      developerFields,
      int localId = 0,
      Endian endian = Endian.little})
      : growable = definitionMessage == null,
        super(
            name: DiveGasMessage.NAME,
            globalId: DiveGasMessage.ID,
            localId: definitionMessage?.localId ?? localId,
            endian: definitionMessage?.endian ?? endian,
            definitionMessage: definitionMessage,
            developerFields: developerFields,
            fields: [
              MessageIndexField(
                  size: definitionMessage
                          ?.getFieldDefinition(MessageIndexField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              DiveGasHeliumContentField(
                  size: definitionMessage
                          ?.getFieldDefinition(DiveGasHeliumContentField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              DiveGasOxygenContentField(
                  size: definitionMessage
                          ?.getFieldDefinition(DiveGasOxygenContentField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              DiveGasStatusField(
                  size: definitionMessage
                          ?.getFieldDefinition(DiveGasStatusField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null)
            ]);

  static const ID = 259;
  static const NAME = 'dive_gas';

  final bool growable;

  static DiveGasMessage fromBytes(
      DefinitionMessage definitionMessage, Uint8List bytes) {
    final message = DiveGasMessage(definitionMessage: definitionMessage);
    message.readFromBytes(bytes);
    return message;
  }

  int? get messageIndex {
    final field = getField(MessageIndexField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set messageIndex(int? value) {
    final field = getField(MessageIndexField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  int? get heliumContent {
    final field = getField(DiveGasHeliumContentField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set heliumContent(int? value) {
    final field = getField(DiveGasHeliumContentField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  int? get oxygenContent {
    final field = getField(DiveGasOxygenContentField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set oxygenContent(int? value) {
    final field = getField(DiveGasOxygenContentField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  DiveGasStatus? get status {
    final field = getField(DiveGasStatusField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      final value = field.getValue(subField: subField);
      if (value == null) {
        return null;
      }
      return DiveGasStatusExt.fromValue(value);
    } else {
      return null;
    }
  }

  set status(DiveGasStatus? value) {
    final field = getField(DiveGasStatusField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value.value, subField);
      }
    }
  }
}

class DiveGasHeliumContentField extends Field {
  DiveGasHeliumContentField({int size = 0, bool growable = true})
      : super(
            name: 'helium_content',
            id: ID,
            type: BaseType.UINT8,
            offset: 0,
            scale: 1,
            size: size,
            units: 'percent',
            mainTypeName: '',
            growable: growable,
            subFields: []);

  static const ID = 0;
}

class DiveGasOxygenContentField extends Field {
  DiveGasOxygenContentField({int size = 0, bool growable = true})
      : super(
            name: 'oxygen_content',
            id: ID,
            type: BaseType.UINT8,
            offset: 0,
            scale: 1,
            size: size,
            units: 'percent',
            mainTypeName: '',
            growable: growable,
            subFields: []);

  static const ID = 1;
}

class DiveGasStatusField extends Field {
  DiveGasStatusField({int size = 0, bool growable = true})
      : super(
            name: 'status',
            id: ID,
            type: BaseType.ENUM,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 2;
}
