/// Autogenerated. Do not modify.
///
/// Profile: 21.60
import 'dart:typed_data';

import '../../base_type.dart';
import '../../data_message.dart';
import '../../definition_message.dart';
import '../../field.dart';
import '../../sub_field.dart';
import '../profile_type.dart';
import 'common_fields.dart';

class HrmProfileMessage extends DataMessage {
  HrmProfileMessage(
      {definitionMessage,
      developerFields,
      int localId = 0,
      Endian endian = Endian.little})
      : growable = definitionMessage == null,
        super(
            name: HrmProfileMessage.NAME,
            globalId: HrmProfileMessage.ID,
            localId: definitionMessage?.localId ?? localId,
            endian: definitionMessage?.endian ?? endian,
            definitionMessage: definitionMessage,
            developerFields: developerFields,
            fields: [
              MessageIndexField(
                  size: definitionMessage
                          ?.getFieldDefinition(MessageIndexField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              HrmProfileEnabledField(
                  size: definitionMessage
                          ?.getFieldDefinition(HrmProfileEnabledField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              HrmProfileHrmAntIdField(
                  size: definitionMessage
                          ?.getFieldDefinition(HrmProfileHrmAntIdField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              HrmProfileLogHrvField(
                  size: definitionMessage
                          ?.getFieldDefinition(HrmProfileLogHrvField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              HrmProfileHrmAntIdTransTypeField(
                  size: definitionMessage
                          ?.getFieldDefinition(
                              HrmProfileHrmAntIdTransTypeField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null)
            ]);

  static const ID = 4;
  static const NAME = 'hrm_profile';

  final bool growable;

  static HrmProfileMessage fromBytes(
      DefinitionMessage definitionMessage, Uint8List bytes) {
    final message = HrmProfileMessage(definitionMessage: definitionMessage);
    message.readFromBytes(bytes);
    return message;
  }

  int? get messageIndex {
    final field = getField(MessageIndexField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set messageIndex(int? value) {
    final field = getField(MessageIndexField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  bool? get enabled {
    final field = getField(HrmProfileEnabledField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set enabled(bool? value) {
    final field = getField(HrmProfileEnabledField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  int? get hrmAntId {
    final field = getField(HrmProfileHrmAntIdField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set hrmAntId(int? value) {
    final field = getField(HrmProfileHrmAntIdField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  bool? get logHrv {
    final field = getField(HrmProfileLogHrvField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set logHrv(bool? value) {
    final field = getField(HrmProfileLogHrvField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  int? get hrmAntIdTransType {
    final field = getField(HrmProfileHrmAntIdTransTypeField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set hrmAntIdTransType(int? value) {
    final field = getField(HrmProfileHrmAntIdTransTypeField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }
}

class HrmProfileEnabledField extends Field {
  HrmProfileEnabledField({int size = 0, bool growable = true})
      : super(
            name: 'enabled',
            id: ID,
            type: BaseType.UINT8,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 0;
}

class HrmProfileHrmAntIdField extends Field {
  HrmProfileHrmAntIdField({int size = 0, bool growable = true})
      : super(
            name: 'hrm_ant_id',
            id: ID,
            type: BaseType.UINT16Z,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 1;
}

class HrmProfileLogHrvField extends Field {
  HrmProfileLogHrvField({int size = 0, bool growable = true})
      : super(
            name: 'log_hrv',
            id: ID,
            type: BaseType.UINT8,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 2;
}

class HrmProfileHrmAntIdTransTypeField extends Field {
  HrmProfileHrmAntIdTransTypeField({int size = 0, bool growable = true})
      : super(
            name: 'hrm_ant_id_trans_type',
            id: ID,
            type: BaseType.UINT8Z,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 3;
}
