/// Autogenerated. Do not modify.
///
/// Profile: 21.60
import 'dart:typed_data';

import '../../base_type.dart';
import '../../data_message.dart';
import '../../definition_message.dart';
import '../../field.dart';
import '../../sub_field.dart';
import '../profile_type.dart';
import 'common_fields.dart';

class HrvMessage extends DataMessage {
  HrvMessage(
      {definitionMessage,
      developerFields,
      int localId = 0,
      Endian endian = Endian.little})
      : growable = definitionMessage == null,
        super(
            name: HrvMessage.NAME,
            globalId: HrvMessage.ID,
            localId: definitionMessage?.localId ?? localId,
            endian: definitionMessage?.endian ?? endian,
            definitionMessage: definitionMessage,
            developerFields: developerFields,
            fields: [
              HrvTimeField(
                  size: definitionMessage
                          ?.getFieldDefinition(HrvTimeField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null)
            ]);

  static const ID = 78;
  static const NAME = 'hrv';

  final bool growable;

  static HrvMessage fromBytes(
      DefinitionMessage definitionMessage, Uint8List bytes) {
    final message = HrvMessage(definitionMessage: definitionMessage);
    message.readFromBytes(bytes);
    return message;
  }

  double? get time {
    final field = getField(HrvTimeField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set time(double? value) {
    final field = getField(HrvTimeField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }
}

class HrvTimeField extends Field {
  HrvTimeField({int size = 0, bool growable = true})
      : super(
            name: 'time',
            id: ID,
            type: BaseType.UINT16,
            offset: 0,
            scale: 1000,
            size: size,
            units: 's',
            mainTypeName: '',
            growable: growable,
            subFields: []);

  static const ID = 0;
}
