/// Autogenerated. Do not modify.
///
/// Profile: 21.60
import 'dart:typed_data';

import '../../base_type.dart';
import '../../data_message.dart';
import '../../definition_message.dart';
import '../../field.dart';
import '../../sub_field.dart';
import '../profile_type.dart';
import 'common_fields.dart';

class MetZoneMessage extends DataMessage {
  MetZoneMessage(
      {definitionMessage,
      developerFields,
      int localId = 0,
      Endian endian = Endian.little})
      : growable = definitionMessage == null,
        super(
            name: MetZoneMessage.NAME,
            globalId: MetZoneMessage.ID,
            localId: definitionMessage?.localId ?? localId,
            endian: definitionMessage?.endian ?? endian,
            definitionMessage: definitionMessage,
            developerFields: developerFields,
            fields: [
              MessageIndexField(
                  size: definitionMessage
                          ?.getFieldDefinition(MessageIndexField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              MetZoneHighBpmField(
                  size: definitionMessage
                          ?.getFieldDefinition(MetZoneHighBpmField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              MetZoneCaloriesField(
                  size: definitionMessage
                          ?.getFieldDefinition(MetZoneCaloriesField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              MetZoneFatCaloriesField(
                  size: definitionMessage
                          ?.getFieldDefinition(MetZoneFatCaloriesField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null)
            ]);

  static const ID = 10;
  static const NAME = 'met_zone';

  final bool growable;

  static MetZoneMessage fromBytes(
      DefinitionMessage definitionMessage, Uint8List bytes) {
    final message = MetZoneMessage(definitionMessage: definitionMessage);
    message.readFromBytes(bytes);
    return message;
  }

  int? get messageIndex {
    final field = getField(MessageIndexField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set messageIndex(int? value) {
    final field = getField(MessageIndexField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  int? get highBpm {
    final field = getField(MetZoneHighBpmField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set highBpm(int? value) {
    final field = getField(MetZoneHighBpmField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  double? get calories {
    final field = getField(MetZoneCaloriesField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set calories(double? value) {
    final field = getField(MetZoneCaloriesField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  double? get fatCalories {
    final field = getField(MetZoneFatCaloriesField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set fatCalories(double? value) {
    final field = getField(MetZoneFatCaloriesField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }
}

class MetZoneHighBpmField extends Field {
  MetZoneHighBpmField({int size = 0, bool growable = true})
      : super(
            name: 'high_bpm',
            id: ID,
            type: BaseType.UINT8,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 1;
}

class MetZoneCaloriesField extends Field {
  MetZoneCaloriesField({int size = 0, bool growable = true})
      : super(
            name: 'calories',
            id: ID,
            type: BaseType.UINT16,
            offset: 0,
            scale: 10,
            size: size,
            units: 'kcal / min',
            mainTypeName: '',
            growable: growable,
            subFields: []);

  static const ID = 2;
}

class MetZoneFatCaloriesField extends Field {
  MetZoneFatCaloriesField({int size = 0, bool growable = true})
      : super(
            name: 'fat_calories',
            id: ID,
            type: BaseType.UINT8,
            offset: 0,
            scale: 10,
            size: size,
            units: 'kcal / min',
            mainTypeName: '',
            growable: growable,
            subFields: []);

  static const ID = 3;
}
