/// Autogenerated. Do not modify.
///
/// Profile: 21.60
import 'dart:typed_data';

import '../../base_type.dart';
import '../../data_message.dart';
import '../../definition_message.dart';
import '../../field.dart';
import '../../sub_field.dart';
import '../profile_type.dart';
import 'common_fields.dart';

class VideoMessage extends DataMessage {
  VideoMessage(
      {definitionMessage,
      developerFields,
      int localId = 0,
      Endian endian = Endian.little})
      : growable = definitionMessage == null,
        super(
            name: VideoMessage.NAME,
            globalId: VideoMessage.ID,
            localId: definitionMessage?.localId ?? localId,
            endian: definitionMessage?.endian ?? endian,
            definitionMessage: definitionMessage,
            developerFields: developerFields,
            fields: [
              VideoUrlField(
                  size: definitionMessage
                          ?.getFieldDefinition(VideoUrlField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              VideoHostingProviderField(
                  size: definitionMessage
                          ?.getFieldDefinition(VideoHostingProviderField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              VideoDurationField(
                  size: definitionMessage
                          ?.getFieldDefinition(VideoDurationField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null)
            ]);

  static const ID = 184;
  static const NAME = 'video';

  final bool growable;

  static VideoMessage fromBytes(
      DefinitionMessage definitionMessage, Uint8List bytes) {
    final message = VideoMessage(definitionMessage: definitionMessage);
    message.readFromBytes(bytes);
    return message;
  }

  String? get url {
    final field = getField(VideoUrlField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set url(String? value) {
    final field = getField(VideoUrlField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  String? get hostingProvider {
    final field = getField(VideoHostingProviderField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set hostingProvider(String? value) {
    final field = getField(VideoHostingProviderField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }

  int? get duration {
    final field = getField(VideoDurationField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  set duration(int? value) {
    final field = getField(VideoDurationField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    }
  }
}

class VideoUrlField extends Field {
  VideoUrlField({int size = 0, bool growable = true})
      : super(
            name: 'url',
            id: ID,
            type: BaseType.STRING,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 0;
}

class VideoHostingProviderField extends Field {
  VideoHostingProviderField({int size = 0, bool growable = true})
      : super(
            name: 'hosting_provider',
            id: ID,
            type: BaseType.STRING,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 1;
}

class VideoDurationField extends Field {
  VideoDurationField({int size = 0, bool growable = true})
      : super(
            name: 'duration',
            id: ID,
            type: BaseType.UINT32,
            offset: 0,
            scale: 1,
            size: size,
            units: 'ms',
            mainTypeName: '',
            growable: growable,
            subFields: []);

  static const ID = 2;
}
